"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorEditTooltip = void 0;
var react_1 = __importStar(require("react"));
var react_2 = require("@headlessui/react");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var html_editor_1 = __importDefault(require("./html-editor"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var HtmlEditorEditTooltip = function (props) {
    var show = props.show, lowlight = props.lowlight;
    var refDialog = (0, react_1.useRef)(null);
    var _a = (0, react_1.useState)(""), content = _a[0], setContent = _a[1];
    var _b = (0, react_1.useState)(""), focus = _b[0], setFocus = _b[1];
    var _c = (0, react_1.useState)({
        width: 0,
        height: 0
    }), size = _c[0], setSize = _c[1];
    (0, react_1.useEffect)(function () {
        (0, primeobjects_helper_util_1.doNothing)(focus);
        setContent(props.content ? props.content : "");
    }, [props.content]);
    (0, react_1.useEffect)(function () {
        refDialog.current && refDialog.current.focus();
    }, [props.show, refDialog.current]);
    var onUpdate = function () {
        props.onUpdate(content);
        props.onClose();
    };
    var onResize = function (width, height) {
        setSize({ width: width, height: height });
    };
    var onClickWrapper = function (e) {
        if (e.target.className && e.target.className.indexOf("editor-wrapper-for-tooltip") >= 0)
            setFocus(Date.now());
    };
    var onChange = function (content) {
        setContent(content);
    };
    return (react_1.default.createElement(react_2.Transition.Root, { show: show, as: react_1.Fragment },
        react_1.default.createElement(react_2.Dialog, { as: "div", className: "relative z-10", onClose: function () { } },
            react_1.default.createElement(react_2.Transition.Child, { as: react_1.Fragment, enter: "ease-out duration-300", enterFrom: "opacity-0", enterTo: "opacity-100", leave: "ease-in duration-200", leaveFrom: "opacity-100", leaveTo: "opacity-0" },
                react_1.default.createElement("div", { className: "fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity" })),
            react_1.default.createElement("div", { className: "fixed z-10 inset-0 overflow-y-auto" },
                react_1.default.createElement(primeobjects_ui_web_basic_1.ResizeDetectorDiv, { className: "flex sm:items-center justify-center h-full p-4 text-center sm:p-0", onDetect: onResize },
                    react_1.default.createElement(react_2.Transition.Child, { as: react_1.Fragment, enter: "ease-out duration-300", enterFrom: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95", enterTo: "opacity-100 translate-y-0 sm:scale-100", leave: "ease-in duration-200", leaveFrom: "opacity-100 translate-y-0 sm:scale-100", leaveTo: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95" },
                        react_1.default.createElement(react_2.Dialog.Panel, { className: "relative max-h-full bg-white rounded-lg px-4 pt-5 pb-4 text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:max-w-sm lg:max-w-md xl:max-w-lg sm:w-full sm:p-6" },
                            react_1.default.createElement("div", { className: "html-editor editor-wrapper-for-tooltip overflow-hidden overflow-y-auto border rounded-lg", style: {
                                    height: size.height ? size.height - 400 : 300
                                }, onClick: onClickWrapper },
                                react_1.default.createElement(html_editor_1.default, __assign({ lowlight: lowlight, placeholder: "Please type your tooltip here ...", content: content }, props.tooltipEditorProps, { className: "overflow-y-auto h-full", inputClassName: "p-6 h-full", supportTooltips: false, onChange: onChange }))),
                            react_1.default.createElement("div", { className: "mt-5 sm:mt-6 flex flex-row" },
                                react_1.default.createElement("div", { className: "flex-1" }),
                                react_1.default.createElement("button", { type: "button", className: "mr-2 inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-gray-200 text-base font-medium text-gray-800 hover:bg-gray-300 focus:outline-none focus:ring-1 focus:ring-offset-1 focus:ring-gray-300 sm:text-sm", onClick: props.onClose }, "Cancel"),
                                react_1.default.createElement("button", { ref: function (ref) {
                                        if (ref) {
                                            refDialog.current = ref;
                                        }
                                    }, type: "button", className: "inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-sky-600 text-base font-medium text-white hover:bg-sky-700 focus:outline-none focus:ring-1 focus:ring-offset-1 focus:ring-sky-500 sm:text-sm", onClick: onUpdate }, "Update")))))))));
};
exports.HtmlEditorEditTooltip = HtmlEditorEditTooltip;
exports.default = exports.HtmlEditorEditTooltip;
//# sourceMappingURL=html-editor-edit-tooltip.js.map