"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTextFromSelectedHTMLSegment = exports.getMarksFromSelectedHTMLSegment = exports.getSelectedNodes = exports.getSelectedHightlightText = exports.getSelectedHightlightColor = void 0;
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var getSelectedHightlightColor = function (editor) {
    var _a, _b, _c, _d;
    var marks = (0, exports.getMarksFromSelectedHTMLSegment)((0, exports.getSelectedNodes)(editor), []);
    for (var i = 0; i < marks.length; i++) {
        if ((_b = (_a = marks[i]) === null || _a === void 0 ? void 0 : _a.attrs) === null || _b === void 0 ? void 0 : _b.color)
            return (_d = (_c = marks[i]) === null || _c === void 0 ? void 0 : _c.attrs) === null || _d === void 0 ? void 0 : _d.color;
    }
    return null;
};
exports.getSelectedHightlightColor = getSelectedHightlightColor;
var getSelectedHightlightText = function (editor) {
    return (0, exports.getTextFromSelectedHTMLSegment)((0, exports.getSelectedNodes)(editor));
};
exports.getSelectedHightlightText = getSelectedHightlightText;
var getSelectedNodes = function (editor) {
    var _a, _b;
    return (_b = (_a = editor.view.state) === null || _a === void 0 ? void 0 : _a.selection) === null || _b === void 0 ? void 0 : _b.content();
};
exports.getSelectedNodes = getSelectedNodes;
var getMarksFromSelectedHTMLSegment = function (nodes, marks) {
    if ((0, lodash_1.isNil)(nodes))
        return [];
    if (!(0, lodash_1.isArray)(nodes))
        return (0, exports.getMarksFromSelectedHTMLSegment)(nodes === null || nodes === void 0 ? void 0 : nodes.content, marks);
    if (!(0, lodash_1.isArray)(marks))
        marks = [];
    for (var i = 0; (0, lodash_1.isArray)(nodes) && i < nodes.length; i++) {
        var node = nodes[i];
        if ((0, lodash_1.isArray)(node.marks) && node.marks.length > 0) {
            marks = (0, lodash_1.merge)(marks, node.marks);
        }
        else {
            marks = (0, exports.getMarksFromSelectedHTMLSegment)(node === null || node === void 0 ? void 0 : node.content, marks);
        }
    }
    return marks;
};
exports.getMarksFromSelectedHTMLSegment = getMarksFromSelectedHTMLSegment;
var getTextFromSelectedHTMLSegment = function (nodes) {
    if ((0, lodash_1.isNil)(nodes))
        return "";
    if (!(0, lodash_1.isArray)(nodes))
        return (0, exports.getTextFromSelectedHTMLSegment)(nodes === null || nodes === void 0 ? void 0 : nodes.content);
    return (0, lodash_1.map)(nodes, function (node) {
        return (0, core_1.isNonEmptyString)(node.text) ? node.text : (0, exports.getTextFromSelectedHTMLSegment)(node);
    }).join(" ");
};
exports.getTextFromSelectedHTMLSegment = getTextFromSelectedHTMLSegment;
//# sourceMappingURL=html-helper.js.map