//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React, { useState } from "react";
import { NodeViewWrapper, NodeViewContent } from "@tiptap/react";
import Select from "primeobjects-ui-web-application/build/cjs/controls/antd/select";
import SelectOption from "primeobjects-ui-web-application/build/cjs/controls/antd/select-option";
import { map, find } from "lodash";
export var HtmlFieldCode = function (props) {
    var _a, _b;
    var node = props.node, updateAttributes = props.updateAttributes, extension = props.extension, readonly = props.readonly;
    var defaultValue = "javascript";
    var _c = useState(((_a = node === null || node === void 0 ? void 0 : node.attrs) === null || _a === void 0 ? void 0 : _a.language) ? (_b = node === null || node === void 0 ? void 0 : node.attrs) === null || _b === void 0 ? void 0 : _b.language : defaultValue), value = _c[0], setValue = _c[1];
    var langs = extension.options.lowlight.listLanguages();
    var renderOptions = function () {
        return map(langs, function (lang, index) {
            return (React.createElement(SelectOption, { key: index, value: lang }, lang));
        });
    };
    var onChange = function (newValue) {
        if (find(langs, function (l) { return l == newValue; })) {
            setValue(newValue);
            updateAttributes({ language: newValue });
        }
        else {
            setValue(defaultValue);
            updateAttributes({ language: defaultValue });
        }
    };
    var getCurrentLang = function () {
        var cur = find(langs, function (l) { return l == value; });
        return cur ? cur : "undefined";
    };
    return (React.createElement(NodeViewWrapper, { className: "code-block" },
        readonly ? (React.createElement("div", { className: "code-block-lang readonly" }, getCurrentLang())) : (React.createElement(Select, { showSearch: true, className: "code-block-lang", defaultValue: defaultValue, onChange: onChange, value: value }, renderOptions())),
        React.createElement("pre", null,
            React.createElement(NodeViewContent, { as: "code" }))));
};
export default HtmlFieldCode;
//# sourceMappingURL=html-code.js.map