//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Fragment, useEffect, useRef, useState } from "react";
import { Dialog, Transition } from "@headlessui/react";
import { ResizeDetectorDiv } from "primeobjects-ui-web-basic";
import HtmlEditor from "./html-editor";
import { doNothing } from "primeobjects-helper-util";
export var HtmlEditorEditTooltip = function (props) {
    var show = props.show, lowlight = props.lowlight;
    var refDialog = useRef(null);
    var _a = useState(""), content = _a[0], setContent = _a[1];
    var _b = useState(""), focus = _b[0], setFocus = _b[1];
    var _c = useState({
        width: 0,
        height: 0
    }), size = _c[0], setSize = _c[1];
    useEffect(function () {
        doNothing(focus);
        setContent(props.content ? props.content : "");
    }, [props.content]);
    useEffect(function () {
        refDialog.current && refDialog.current.focus();
    }, [props.show, refDialog.current]);
    var onUpdate = function () {
        props.onUpdate(content);
        props.onClose();
    };
    var onResize = function (width, height) {
        setSize({ width: width, height: height });
    };
    var onClickWrapper = function (e) {
        if (e.target.className && e.target.className.indexOf("editor-wrapper-for-tooltip") >= 0)
            setFocus(Date.now());
    };
    var onChange = function (content) {
        setContent(content);
    };
    return (React.createElement(Transition.Root, { show: show, as: Fragment },
        React.createElement(Dialog, { as: "div", className: "relative z-10", onClose: function () { } },
            React.createElement(Transition.Child, { as: Fragment, enter: "ease-out duration-300", enterFrom: "opacity-0", enterTo: "opacity-100", leave: "ease-in duration-200", leaveFrom: "opacity-100", leaveTo: "opacity-0" },
                React.createElement("div", { className: "fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity" })),
            React.createElement("div", { className: "fixed z-10 inset-0 overflow-y-auto" },
                React.createElement(ResizeDetectorDiv, { className: "flex sm:items-center justify-center h-full p-4 text-center sm:p-0", onDetect: onResize },
                    React.createElement(Transition.Child, { as: Fragment, enter: "ease-out duration-300", enterFrom: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95", enterTo: "opacity-100 translate-y-0 sm:scale-100", leave: "ease-in duration-200", leaveFrom: "opacity-100 translate-y-0 sm:scale-100", leaveTo: "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-95" },
                        React.createElement(Dialog.Panel, { className: "relative max-h-full bg-white rounded-lg px-4 pt-5 pb-4 text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:max-w-sm lg:max-w-md xl:max-w-lg sm:w-full sm:p-6" },
                            React.createElement("div", { className: "html-editor editor-wrapper-for-tooltip overflow-hidden overflow-y-auto border rounded-lg", style: {
                                    height: size.height ? size.height - 400 : 300
                                }, onClick: onClickWrapper },
                                React.createElement(HtmlEditor, __assign({ lowlight: lowlight, placeholder: "Please type your tooltip here ...", content: content }, props.tooltipEditorProps, { className: "overflow-y-auto h-full", inputClassName: "p-6 h-full", supportTooltips: false, onChange: onChange }))),
                            React.createElement("div", { className: "mt-5 sm:mt-6 flex flex-row" },
                                React.createElement("div", { className: "flex-1" }),
                                React.createElement("button", { type: "button", className: "mr-2 inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-gray-200 text-base font-medium text-gray-800 hover:bg-gray-300 focus:outline-none focus:ring-1 focus:ring-offset-1 focus:ring-gray-300 sm:text-sm", onClick: props.onClose }, "Cancel"),
                                React.createElement("button", { ref: function (ref) {
                                        if (ref) {
                                            refDialog.current = ref;
                                        }
                                    }, type: "button", className: "inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-sky-600 text-base font-medium text-white hover:bg-sky-700 focus:outline-none focus:ring-1 focus:ring-offset-1 focus:ring-sky-500 sm:text-sm", onClick: onUpdate }, "Update")))))))));
};
export default HtmlEditorEditTooltip;
//# sourceMappingURL=html-editor-edit-tooltip.js.map