import React, { CSSProperties } from "react";
import { THtmlEditorHighlightCustomButton } from "./html-editor-type";
export type THtmlEditorProps = {
    content: string;
    tooltips?: Record<string, any>;
    placeholder?: string;
    style?: CSSProperties;
    className?: string;
    inputStyle?: CSSProperties;
    inputClassName?: string;
    supportTooltips?: boolean;
    hideH1?: boolean;
    hideH2?: boolean;
    hideH3?: boolean;
    hideH4?: boolean;
    supportHighlight?: boolean;
    supportSourceCode?: boolean;
    readonly?: boolean;
    disabled?: boolean;
    id?: string;
    onChange?: (content: string, tooltips: Record<string, any>) => void;
    onReady?: () => void;
    highlightCustomButtons?: THtmlEditorHighlightCustomButton[];
    onHighlight?: (editor: any, color: string) => void;
    recordId?: string;
    entityName?: string;
    attributeName?: string;
    highlightColors?: string[];
    getEditor?: (editor: any) => void;
    lowlight: any;
};
export declare const HtmlEditor: React.MemoExoticComponent<{
    (props: THtmlEditorProps): JSX.Element;
    displayName: string;
}>;
export default HtmlEditor;
