//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import { map, isArray, isNil, merge } from "lodash";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
export var getSelectedHightlightColor = function (editor) {
    var _a, _b, _c, _d;
    var marks = getMarksFromSelectedHTMLSegment(getSelectedNodes(editor), []);
    for (var i = 0; i < marks.length; i++) {
        if ((_b = (_a = marks[i]) === null || _a === void 0 ? void 0 : _a.attrs) === null || _b === void 0 ? void 0 : _b.color)
            return (_d = (_c = marks[i]) === null || _c === void 0 ? void 0 : _c.attrs) === null || _d === void 0 ? void 0 : _d.color;
    }
    return null;
};
export var getSelectedHightlightText = function (editor) {
    return getTextFromSelectedHTMLSegment(getSelectedNodes(editor));
};
export var getSelectedNodes = function (editor) {
    var _a, _b;
    return (_b = (_a = editor.view.state) === null || _a === void 0 ? void 0 : _a.selection) === null || _b === void 0 ? void 0 : _b.content();
};
export var getMarksFromSelectedHTMLSegment = function (nodes, marks) {
    if (isNil(nodes))
        return [];
    if (!isArray(nodes))
        return getMarksFromSelectedHTMLSegment(nodes === null || nodes === void 0 ? void 0 : nodes.content, marks);
    if (!isArray(marks))
        marks = [];
    for (var i = 0; isArray(nodes) && i < nodes.length; i++) {
        var node = nodes[i];
        if (isArray(node.marks) && node.marks.length > 0) {
            marks = merge(marks, node.marks);
        }
        else {
            marks = getMarksFromSelectedHTMLSegment(node === null || node === void 0 ? void 0 : node.content, marks);
        }
    }
    return marks;
};
export var getTextFromSelectedHTMLSegment = function (nodes) {
    if (isNil(nodes))
        return "";
    if (!isArray(nodes))
        return getTextFromSelectedHTMLSegment(nodes === null || nodes === void 0 ? void 0 : nodes.content);
    return map(nodes, function (node) {
        return isNonEmptyString(node.text) ? node.text : getTextFromSelectedHTMLSegment(node);
    }).join(" ");
};
//# sourceMappingURL=html-helper.js.map